LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY tb_CmdM3 IS
END tb_CmdM3;
 
ARCHITECTURE behavior OF tb_CmdM3 IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT CmdM3
    PORT(
         Rst : IN  std_logic;
         Clk : IN  std_logic;
         En : IN  std_logic_vector(2 downto 0);
         Vitesse1 : IN  std_logic_vector(7 downto 0);
         Vitesse2 : IN  std_logic_vector(7 downto 0);
         Vitesse3 : IN  std_logic_vector(7 downto 0);
         ClkOut : OUT  std_logic;
         PWM_out : OUT  std_logic_vector(2 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal Rst : std_logic := '0';
   signal Clk : std_logic := '0';
   signal En : std_logic_vector(2 downto 0) := (others => '0');
   signal Vitesse1 : std_logic_vector(7 downto 0) := (others => '0');
   signal Vitesse2 : std_logic_vector(7 downto 0) := (others => '0');
   signal Vitesse3 : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal ClkOut : std_logic;
   signal PWM_out :  std_logic_vector(2 downto 0);
   
   -- Clock period definitions
   constant Clk_period : time := 10 ns;
   constant ClkOut_period : time := 10 ns;
 
BEGIN
 
	
	-- Instantiate the Unit Under Test (UUT)
	uut: CmdM3 PORT MAP (
		Rst => Rst,
		Clk => Clk,
		En => En,
		Vitesse1 => Vitesse1,
		Vitesse2 => Vitesse2,
		Vitesse3 => Vitesse3,
		ClkOut => ClkOut,
		PWM_out => PWM_out
		);
	
	-- Clock process definitions
	Clk_process :process
	begin
		Clk <= '0';
		wait for Clk_period/2;
		Clk <= '1';
		wait for Clk_period/2;
	end process;
	
	En <= b"111";
	Rst <= '0'; 

	Vitesse1 <= x"0f";
	Vitesse2 <= x"f0";
	Vitesse3 <= x"3f";

END;
