LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
 
ENTITY tb_CmdMaCC IS
END tb_CmdMaCC;
 
ARCHITECTURE behavior OF tb_CmdMaCC IS 
 
 
    COMPONENT CmdMaCC
    PORT(
         Rst : IN  std_logic;
         Clk : IN  std_logic;
         En : IN  std_logic;
         RapportCyc : IN  std_logic_vector(7 downto 0);
		 ClkOut : out  STD_LOGIC;
         PWM_out : OUT  std_logic
        );
    END COMPONENT;
    

   -- Entres 
   signal Rst : std_logic := '0';
   signal Clk : std_logic := '0';
   signal En : std_logic := '0';
   signal RapportCyc : std_logic_vector(7 downto 0) := (others => '0');

 	-- Sorties
   signal PWM_out : std_logic;
   signal ClkOut : std_logic;

   -- priode
   constant Clk_period : time := 10 ns;
 
BEGIN
 
	uut: CmdMaCC PORT MAP (
		Rst => Rst,
		Clk => Clk,
		En => En,
		RapportCyc => RapportCyc,
		ClkOut => ClkOut,
		PWM_out => PWM_out
		);
	
	Clk_process :process
	begin
		Clk <= '0';
		wait for Clk_period/2;
		Clk <= '1';
		wait for Clk_period/2;
	end process;
	
	Rst <= '0';
	En <= '1'; 
	
--	RapportCyc <= x"C8"; -- 200
--	RapportCyc <= x"40"; -- 64
	RapportCyc <= x"0f"; -- 0

END;
