LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
use ieee.std_logic_unsigned.all;


 
ENTITY tb_ComparN IS
END tb_ComparN;
 
ARCHITECTURE behavior OF tb_ComparN IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT ComparN
    PORT(
         Rst : IN  std_logic;
         En : IN  std_logic;
         Clk : IN  std_logic;
         D_in_P : IN  std_logic_vector(7 downto 0);
         D_in_N : IN  std_logic_vector(7 downto 0);
         D_out_CMP : OUT  std_logic
        );
    END COMPONENT;
    

   --Inputs
   signal Rst : std_logic := '0';
   signal En : std_logic := '0';
   signal Clk : std_logic := '0';
   signal D_in_P : std_logic_vector(7 downto 0) := (others => '0');
   signal D_in_N : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal D_out_CMP : std_logic;

   -- Clock period definitions
   constant Clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
	uut: ComparN PORT MAP (
		Rst => Rst,
		En => En,
		Clk => Clk,
		D_in_P => D_in_P,
		D_in_N => D_in_N,
		D_out_CMP => D_out_CMP
		);
	
	-- Clock process definitions
	Clk_process :process
	begin
		Clk <= '0';
		wait for Clk_period/2;
		Clk <= '1';
		wait for Clk_period/2;
	end process;
	
	D_in_N <= x"F0"; 
	Rst <= '0';
	En <= '1';
	
	D_in_P_process :process (Clk)
	begin
		if Clk = '1' and Clk'event then
			D_in_P <= D_in_P + 1;
		end if ;
	end process;
	
	
	
	

END;
