LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 


 
ENTITY tb_TriangGen IS
END tb_TriangGen;
 
ARCHITECTURE behavior OF tb_TriangGen IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT TriangGen
    PORT(
         Rst : IN  std_logic;
         En : IN  std_logic;
         Clk : IN  std_logic;
         Triag_out : OUT  std_logic_vector(7 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal Rst : std_logic := '0';
   signal En : std_logic := '0';
   signal Clk : std_logic := '0';

 	--Outputs
   signal Triag_out : std_logic_vector(7 downto 0);

   -- Clock period definitions
   constant Clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
	uut: TriangGen PORT MAP (
		Rst => Rst,
		En => En,
		Clk => Clk,
		Triag_out => Triag_out
		);
	
	-- Clock process definitions
	Clk_process :process
	begin
		Clk <= '0';
		wait for Clk_period/2;
		Clk <= '1';
		wait for Clk_period/2;
	end process;
	
	Rst <= '0';
	En <= '1';
	


END;
