library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;


entity ClkGen is
    Port ( Clk_in : in  STD_LOGIC;
		   Rst : in  STD_LOGIC;
           En : in  STD_LOGIC;
		   ClkSel : in  STD_LOGIC_VECTOR (3 downto 0);
           Clk_out : out  STD_LOGIC);
end ClkGen;

architecture Behavioral of ClkGen is

signal ClkSel_tmp :   STD_LOGIC_VECTOR (3 downto 0):=(others =>'0');
signal Clk_out_tmp :   STD_LOGIC:='0';
signal Count_tmp : STD_LOGIC_VECTOR (25 downto 0):=(others =>'0');

begin
	P_ClkOut : process(Rst, Clk_in, En, ClkSel_tmp )
	begin
		if Clk_in = '1' and Clk_in'event then 
			if Rst ='1' then 
				Clk_out_tmp <= '0'; 
			else
				if En = '1' then 
					
					-- Dcodeur BCD to 7 Segments 
					case ClkSel_tmp is
					
						when x"0" 	=> Clk_out_tmp <= Count_tmp(1);
						when x"1" 	=> Clk_out_tmp <= Count_tmp(2); 
						when x"2" 	=> Clk_out_tmp <= Count_tmp(3); 
						when x"3" 	=> Clk_out_tmp <= Count_tmp(4); 
						when x"4" 	=> Clk_out_tmp <= Count_tmp(5); 
						when x"5" 	=> Clk_out_tmp <= Count_tmp(6); 
						when x"6" 	=> Clk_out_tmp <= Count_tmp(7); 
						when x"7" 	=> Clk_out_tmp <= Count_tmp(8); 
						when x"8" 	=> Clk_out_tmp <= Count_tmp(9); 
						when x"9" 	=> Clk_out_tmp <= Count_tmp(10); 
						when x"A" 	=> Clk_out_tmp <= Count_tmp(11); 
						when x"B" 	=> Clk_out_tmp <= Count_tmp(12);  
						when x"C" 	=> Clk_out_tmp <= Count_tmp(13);  
						when x"D" 	=> Clk_out_tmp <= Count_tmp(14);  
						when x"E" 	=> Clk_out_tmp <= Count_tmp(15);  
						when x"F" 	=> Clk_out_tmp <= Count_tmp(16);  
						                                             
						when others => Clk_out_tmp <= Count_tmp(0);  
					end case ;
				else
					Clk_out_tmp <= Clk_out_tmp;
				end if;
			end if;
		end if;
	end process;
	Clk_out <= Clk_out_tmp;
	ClkSel_tmp <= ClkSel; 
	
	P_count : process(Rst, Clk_in, En )
	begin
		if Clk_in = '1' and Clk_in'event then 
			if Rst ='1' then 
				Count_tmp <= (others =>'0'); 
			else
				if En = '1' then 
					Count_tmp <= Count_tmp+1;
				else
					Count_tmp <= Count_tmp;
				end if;
			end if;
		end if;
	end process;
	
	
	
end Behavioral;

