library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity CmdM3 is
    Port ( Rst 		: in  STD_LOGIC;
           Clk 		: in  STD_LOGIC;
           En 		: in  STD_LOGIC_VECTOR (2 downto 0); -- 3 Moteurs
           Vitesse1 : in  STD_LOGIC_VECTOR (7 downto 0);
           Vitesse2 : in  STD_LOGIC_VECTOR (7 downto 0);
           Vitesse3 : in  STD_LOGIC_VECTOR (7 downto 0);
		   ClkOut 	: out  STD_LOGIC;
           PWM_out 	: out  STD_LOGIC_VECTOR (2 downto 0));
end CmdM3;

architecture Behavioral of CmdM3 is


COMPONENT CmdMaCC
PORT(
	Rst : IN std_logic;
	Clk : IN std_logic;
	En : IN std_logic;
	RapportCyc : IN std_logic_vector(7 downto 0);          
	ClkOut : OUT std_logic;
	PWM_out : OUT std_logic
	);
END COMPONENT;

signal ClkOut_1 : std_logic:='0';
signal ClkOut_2 : std_logic:='0';

begin
	M1: CmdMaCC PORT MAP(
		Rst => Rst,
		Clk => Clk,
		En => En(0),
		RapportCyc => Vitesse1,
		ClkOut => ClkOut_1,
		PWM_out => PWM_out(0));
		
	M2: CmdMaCC PORT MAP(
		Rst => Rst,
		Clk => Clk,
		En => En(1),
		RapportCyc => Vitesse1,
		ClkOut => ClkOut_2,
		PWM_out => PWM_out(1));
		
	M3: CmdMaCC PORT MAP(
		Rst => Rst,
		Clk => Clk,
		En => En(2),
		RapportCyc => Vitesse1,
		ClkOut => ClkOut,
		PWM_out => PWM_out(2));
		
	
end Behavioral;

