library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity CmdMaCC is
    Port ( Rst : in  STD_LOGIC;
           Clk : in  STD_LOGIC;
           En : in  STD_LOGIC;
           RapportCyc : in  STD_LOGIC_VECTOR (7 downto 0);
		   ClkOut : out  STD_LOGIC;
           PWM_out : out  STD_LOGIC);
end CmdMaCC;

architecture Behavioral of CmdMaCC is

COMPONENT ComparN
PORT(
	Rst : IN std_logic;
	En : IN std_logic;
	Clk : IN std_logic;
	D_in_P : IN std_logic_vector(7 downto 0);
	D_in_N : IN std_logic_vector(7 downto 0);          
	D_out_CMP : OUT std_logic
	);
END COMPONENT;


COMPONENT ClkGen
PORT(
	Clk_in : IN std_logic;
	Rst : IN std_logic;
	En : IN std_logic;
	ClkSel : IN std_logic_vector(3 downto 0);          
	Clk_out : OUT std_logic
	);
END COMPONENT;

constant ClkSel  	: std_logic_vector(3 downto 0):=x"5"; -- 5:OK     
signal	Clk_out :  std_logic:='0';
--constant Rst :  std_logic:='0';
--constant En :   std_logic:='1';
 
		   

COMPONENT TriangGen
PORT(
	Rst : IN std_logic;
	En : IN std_logic;
	Clk : IN std_logic;          
	Triag_out : OUT std_logic_vector(7 downto 0)
	);
END COMPONENT;

signal Triag_out :  std_logic_vector(7 downto 0):= (others =>'0');

begin

	ClockSet: ClkGen PORT MAP(
		Clk_in => Clk,
		Rst => Rst,
		En => En,
		ClkSel => ClkSel,
		Clk_out => Clk_out
	);
	
	TriangGen8: TriangGen PORT MAP(
		Rst => Rst,
		En => En,
		Clk => Clk_out ,
		Triag_out => Triag_out
	);
	

	Compar8: ComparN PORT MAP(
		Rst => Rst,
		En => En,
		Clk => Clk_out,
		D_in_P => Triag_out,
		D_in_N => RapportCyc,
		D_out_CMP =>PWM_out 
	);
	
	ClkOut <= Clk_out; 
	
end Behavioral;

