library IEEE;
use IEEE.STD_LOGIC_1164.ALL;



entity ComparN is
	Generic ( N : positive := 8
			);
    Port ( Rst : in  STD_LOGIC;
           En : in  STD_LOGIC;
           Clk : in  STD_LOGIC;
           D_in_P : in  STD_LOGIC_VECTOR (N-1 downto 0);
           D_in_N : in  STD_LOGIC_VECTOR (N-1 downto 0);
           D_out_CMP : out  STD_LOGIC);
end ComparN;

architecture Behavioral of ComparN is

signal D_out_CMP_tmp :   STD_LOGIC :='0';

begin
	P_cmp : process(Rst, Clk, En )
	begin
		if Clk = '1' and Clk'event then 
			if Rst ='1' then 
				D_out_CMP_tmp <= '0';
			else
				if En = '1' then 
					if D_in_P > D_in_N then 
						D_out_CMP_tmp <= '1';
					else 
						D_out_CMP_tmp <= '0';
					end if ;
				else
					D_out_CMP_tmp <= D_out_CMP_tmp;
				end if;
			end if;
		end if;
	end process P_cmp;
	D_out_CMP <= D_out_CMP_tmp;
	
end Behavioral;

