library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use ieee.std_logic_unsigned.all;


entity TriangGen is
	Generic ( N  : positive := 8
			);
    Port ( Rst : in  STD_LOGIC;
           En : in  STD_LOGIC;
           Clk : in  STD_LOGIC;
           Triag_out : out  STD_LOGIC_VECTOR (N-1 downto 0));
end TriangGen;

architecture Behavioral of TriangGen is

signal TriagG_tmp :   STD_LOGIC_VECTOR (N-1 downto 0):= (others =>'0');

begin
	P_TriagG : process(Rst, Clk, En )
	begin
		if Clk = '1' and Clk'event then 
			if Rst ='1' then 
				TriagG_tmp <= (others =>'0');
			else
				if En = '1' then 
					TriagG_tmp <= TriagG_tmp+1;
				else
					TriagG_tmp <= TriagG_tmp;
				end if;
			end if;
		end if;
	end process P_TriagG;
	Triag_out <= TriagG_tmp;

end Behavioral;

